/* 6- En un depsito de mercaderas se utiliza un archivo (MERC.DAT) para almacenar informacin referida a cada producto. Al final del da se debe actualizar ese archivo para dejar constancia de las operaciones realizadas en cada jornada. Esta informacin se halla en un archivo llamado NOVE.DAT. */
/* Cada registro del archivo MERC.DAT contiene los campos siguientes:*/
/* Cdigo de producto. */
/* Descripcin.*/
 /* Unidades en existencia.*/
/* Para los registros del archivo NOVE.DAT los campos son:*/
/* Cdigo de producto.*/
/* Cantidad vendida o comprada (negativo significa venta, y positivo, compra).*/
/* Este programa actualiza el archivo MERC.DAT a partir del archivo NOVE.DAT, y devuelve el resultado en el archivo NUEVO.DAT. Todos los archivos estn ordenados de manera ascendente por cdigo de producto. */
/* Aclaracin: no se proveen los archivos MERC.DAT y NOVE.DAT (debido a que son binarios). Debern ser generados antes de la ejecucin de este programa. */
/* Solucin en lenguaje C */

#include <stdio.h>
#include <stdlib.h>

typedef struct {
	int codigo;
	char descripcion[30];
	int existencia;
} t_producto;

typedef struct {
	int codigo;
	int cant_transaccion;
} t_novedad;

typedef enum {FALSO, VERDADERO} t_bool;

void apareo(FILE *, FILE *, FILE *);

int main()
{
	FILE *fmerc, *fnov, *fnuevo;
	if ((fmerc=fopen("merc.dat","rb")) == NULL)
	{
		printf("No se puede abrir el archivo fuente.\n");
		return 1;
	}

	if ((fnov=fopen("nove.dat","rb")) == NULL)
	{
		printf("No se puede abrir el archivo de novedades.\n");
		fclose(fmerc);
		return 1;
	}

	if ((fnuevo=fopen("nuevo.dat","wb")) == NULL)
	{
		printf("No se puede abrir el archivo destino.\n");
		fclose(fmerc);
		fclose(fnov);
		return 1;
	}
	
	apareo(fmerc, fnov, fnuevo);
	fclose(fmerc);
	fclose(fnov);
	fclose(fnuevo);
	return 0;
}

void apareo(FILE* fmerc, FILE* fnov, FILE* fnuevo)
{
	t_producto producto;
	t_novedad novedad;

	rewind(fmerc);
	while (!feof(fmerc))
	{
		fread(&producto, sizeof(t_producto), 1, fmerc);
		rewind(fnov);
		while (!feof(fnov))
	{
		fread(&novedad, sizeof(t_novedad), 1, fnov);
		if (producto.codigo == novedad.codigo)
		{

		/* Actualizar */
		producto.existencia += novedad.cant_transaccion;
		}
	}
	if (fwrite(&producto, sizeof(t_producto), 1, fnuevo) != 1)
		{
		printf("Error de escritura de los datos!");
		return;
		}
	}
}